package ru.dbotthepony.mc.otm.worldgen

import net.minecraft.core.Holder
import net.minecraft.core.registries.BuiltInRegistries
import net.minecraft.core.registries.Registries
import net.minecraft.data.worldgen.features.OreFeatures
import net.minecraft.tags.BlockTags
import net.minecraft.world.level.levelgen.VerticalAnchor
import net.minecraft.world.level.levelgen.feature.ConfiguredFeature
import net.minecraft.world.level.levelgen.feature.Feature
import net.minecraft.world.level.levelgen.feature.configurations.OreConfiguration
import net.minecraft.world.level.levelgen.placement.CountPlacement
import net.minecraft.world.level.levelgen.placement.HeightRangePlacement
import net.minecraft.world.level.levelgen.placement.InSquarePlacement
import net.minecraft.world.level.levelgen.placement.PlacedFeature
import net.minecraft.world.level.levelgen.structure.templatesystem.TagMatchTest
import ru.dbotthepony.mc.otm.registry.MBlocks
import ru.dbotthepony.mc.otm.core.WriteOnce
import ru.dbotthepony.mc.otm.registry.register

@Suppress("UNNECESSARY_NOT_NULL_ASSERTION")
object OreGen {
	private val STONE_ORE_REPLACEABLES = TagMatchTest(BlockTags.STONE_ORE_REPLACEABLES)
	private val DEEPSLATE_ORE_REPLACEABLES = TagMatchTest(BlockTags.DEEPSLATE_ORE_REPLACEABLES)

	val ORE_TRITANIUM_TARGET_LIST = listOf(
		OreConfiguration.target(STONE_ORE_REPLACEABLES, MBlocks.TRITANIUM_ORE.defaultBlockState())!!,
		OreConfiguration.target(DEEPSLATE_ORE_REPLACEABLES, MBlocks.DEEPSLATE_TRITANIUM_ORE.defaultBlockState())!!,
	)

	var ORE_FEATURE_TRITANIUM_NORMAL by WriteOnce<Holder<ConfiguredFeature<*, *>>>()
	var ORE_TRITANIUM_NORMAL by WriteOnce<Holder<PlacedFeature>>()
	var ORE_TRITANIUM_DEEP by WriteOnce<Holder<PlacedFeature>>()

	fun register() {
		// TODO: 1.19.3
		/*val registry = BuiltInRegistries.REGISTRY.get(Registries.CONFIGURED_FEATURE.location())

		ORE_FEATURE_TRITANIUM_NORMAL = CONFIGURED_FEATURE.register("ore_tritanium", ConfiguredFeature(Feature.ORE, OreConfiguration(ORE_TRITANIUM_TARGET_LIST, 9)))

		ORE_TRITANIUM_NORMAL = PLACED_FEATURE.register("ore_tritanium_normal", PlacedFeature(
			ORE_FEATURE_TRITANIUM_NORMAL,
			listOf(
				CountPlacement.of(8),
				InSquarePlacement.spread(),
				HeightRangePlacement.triangle(VerticalAnchor.absolute(0), VerticalAnchor.absolute(50))
			)
		))

		ORE_TRITANIUM_DEEP = PLACED_FEATURE.register("ore_tritanium_deep", PlacedFeature(
			ORE_FEATURE_TRITANIUM_NORMAL,
			listOf(
				CountPlacement.of(10),
				InSquarePlacement.spread(),
				HeightRangePlacement.uniform(VerticalAnchor.aboveBottom(8), VerticalAnchor.absolute(0))
			)
		))*/
	}
}
